import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import javax.swing.JFrame; 
import java.awt.*; 
import java.lang.Object; 
import java.awt.Color; 
import ddf.minim.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class RAGZ_R_1_0_3 extends PApplet {

/////////////////Present Mode Import/////////////////






/////////////////////Aduio////////////////////


Minim minim;

AudioSample sndJump,sndCoin,life,click,tick;
AudioPlayer titleMusic,customizeMusic,gameMusic,gameOver,howToCredits;

////////////////////Images////////////////////

PImage painter,iconHead,worldBackground,worldBackgroundFar;
PImage ground,grass,killBlock,earth,cloud,cloudFar,curveRight,curveLeft,groundEdgeL,groundEdgeR,bottomEarth,sideL,sideR,wallThin,solidThin;
PImage characterStart,characterLegs,characterLegsRun1,characterLegsRun2,characterEyelids;

static final int coinCount = 4, titleCount = 4;
PImage [] coin = new PImage[coinCount],ragzTitle = new PImage[titleCount];

////////////////Character Image Arrays/////////////

static final int sockCount=10,shoeCount=9,undiesCount=12,pantsCount=25,watchCount=2,handsCount=4,hatCount=3,underShirtCount=35,overShirtCount=49,tieCount=14,sweaterVestCount=9,collarCount=49,jacketCount=15,outerCoatCount=11,scarfCount=5;

PImage[] sock = new PImage[sockCount],shoe = new PImage[shoeCount],undies = new PImage[undiesCount],pants = new PImage[pantsCount],
         underShirt = new PImage[underShirtCount],watch = new PImage[watchCount],hands = new PImage[handsCount],hat = new PImage[hatCount],
         overShirt = new PImage[overShirtCount],tie = new PImage[tieCount],sweaterVest = new PImage[sweaterVestCount],collar = new PImage[collarCount],
         jacket = new PImage[jacketCount],outerCoat = new PImage[outerCoatCount],scarf = new PImage[scarfCount], sockRun1 = new PImage[sockCount],
         sockRun2 = new PImage[sockCount],shoeRun1 = new PImage[shoeCount],shoeRun2 = new PImage[shoeCount],undiesRun1 = new PImage[undiesCount],
         undiesRun2 = new PImage[undiesCount],pantsRun1 = new PImage[pantsCount],pantsRun2 = new PImage[pantsCount];

//////////////////////Font///////////////////

PFont bitFont;//8bit font

/////////Global integers/floats/booleans//////////

String versionNumber = "VERSION: R-1.0.3";

boolean start,select,choice,pause,holdingUp,holdingRight,holdingLeft,holdingSpace = false;

int layerSelect = 0;
int sockCall,shoeCall,undiesCall,pantsCall,underShirtCall,watchCall,handsCall,hatCall,overShirtCall,tieCall,sweaterVestCall,collarCall,jacketCall,outerCoatCall,scarfCall = 0;

static final int characterSizeX = 190;
static final int characterSizeY = 425;
static final int characterGameSizeX = 40;
static final int characterGameSizeY = 84;

final float GRAVITY_POWER = 0.5f;
float cameraOffsetX;

float blink = 0;
float blinker;

int flash;
int fade = 75;
int titleFrame;
int lives = 3;
int menuDelay = 0;
int menuSelect = 0;

int level = 0;//Level - 0: Title Screen
              //level - 1: Customize Screen
              //level - 2: Level Lead in screen
              //Level - 3: GamePlay Screen
              //Level - 4: Game Over Screen
              
static final int LEVEL_TITLE = 0;
static final int LEVEL_CUSTOMIZE = 1;
static final int LEVEL_LEADIN = 2;
static final int LEVEL_GAME = 3;
static final int LEVEL_GAMEOVER = 4;
static final int LEVEL_HOWTO = 5;
static final int LEVEL_CREDITS = 6;

//////////////////////Classes/////////////////////

Player thePlayer = new Player();
World theWorld = new World();

//Present Mode Color Change Function
public void setPresentBG (int r, int g, int b) {
((JFrame) frame).getContentPane().setBackground(new Color(r, g, b));
}

public void setup() {
  size(800,600);
  noSmooth();
  setPresentBG (0,255,0) ;
///////////////////Load Font//////////////////////

bitFont = createFont("ARCADEPIX.TTF",40,false);// 8 bit font
textFont(bitFont);

//////////////////Load Images/////////////////////

  painter = loadImage("painter.gif");
  iconHead = loadImage("iconHead.gif");
  ground = loadImage("ground.gif");
  grass = loadImage("grass.gif");
  killBlock = loadImage("killBlock.gif");
  earth = loadImage("earth.gif");
  cloud = loadImage("cloud.gif");
  cloudFar = loadImage("cloudFar.gif");
  curveLeft = loadImage("curve.gif");
  curveRight = loadImage("curveR.gif");
  groundEdgeL = loadImage("groundEdgeL.gif");
  groundEdgeR = loadImage("groundEdgeR.gif");
  bottomEarth = loadImage("bottomEarth.gif");
  sideL = loadImage("wall.gif");
  sideR = loadImage("wallR.gif");
  wallThin = loadImage("wallThin.gif");
  solidThin = loadImage("solidThin.gif");
  characterStart = loadImage("character.gif");
  characterLegs = loadImage("characterLegs.gif");
  characterLegsRun1 = loadImage("characterLegsRun1.gif");
  characterLegsRun2 = loadImage("characterLegsRun2.gif");
  characterEyelids = loadImage("characterEyelids.gif");
  worldBackground = loadImage("worldBackground.gif");
  worldBackgroundFar = loadImage("worldBackgroundFar.gif");

/////////////////Asynchronous Image Load/////////////
  
for (int i = 0; i < sockCount; i++){
    sock[i] = loadImage("sock_"+i+".gif");
    sockRun1[i] = loadImage("sockRun1_"+i+".gif");
    sockRun2[i] = loadImage("sockRun2_"+i+".gif");
  }
for (int i = 0; i < shoeCount; i++){
    shoe[i] = loadImage("shoe_"+i+".gif");
    shoeRun1[i] = loadImage("shoeRun1_"+i+".gif");
    shoeRun2[i] = loadImage("shoeRun2_"+i+".gif");
  }
for (int i = 0; i < undiesCount; i++){
    undies[i] = loadImage("undies_"+i+".gif");
    undiesRun1[i] = loadImage("undiesRun1_"+i+".gif");
    undiesRun2[i] = loadImage("undiesRun2_"+i+".gif");
  }
for (int i = 0; i < pantsCount; i++){
    pants[i] = loadImage("pants_"+i+".gif");
    pantsRun1[i] = loadImage("pantsRun1_"+i+".gif");
    pantsRun2[i] = loadImage("pantsRun2_"+i+".gif");
  }
for (int i = 0; i < handsCount; i++){
    hands[i] = loadImage("hands_"+i+".gif");
  }
for (int i = 0; i < watchCount; i++){
    watch[i] = loadImage("watch_"+i+".gif");
  }
for (int i = 0; i < hatCount; i++){
    hat[i] = loadImage("hat_"+i+".gif");
  }
for (int i = 0; i < underShirtCount; i++){
    underShirt[i] = loadImage("underShirt_"+i+".gif");
  }
for (int i = 0; i < overShirtCount; i++){
    overShirt[i] = loadImage("overShirt_"+i+".gif");
  }
for (int i = 0; i < tieCount; i++){
    tie[i] = loadImage("tie_"+i+".gif");
  }
for (int i = 0; i < collarCount; i++){
    collar[i] = loadImage("collar_"+i+".gif");
  }
for (int i = 0; i < sweaterVestCount; i++){
    sweaterVest[i] = loadImage("vest_"+i+".gif");
  }
for (int i = 0; i < jacketCount; i++){
    jacket[i] = loadImage("jacket_"+i+".gif");
  }
for (int i = 0; i < outerCoatCount; i++){
    outerCoat[i] = loadImage("outerCoat_"+i+".gif");
  }
for (int i = 0; i < scarfCount; i++){
    scarf[i] = loadImage("scarf_"+i+".gif");
  }
  
for (int i = 0; i < coinCount; i++){
    coin[i] = loadImage("coin_"+i+".gif");
  }
for (int i = 0; i < titleCount; i++){
    ragzTitle[i] = loadImage("ragzTitle_"+i+".gif");
}
////////////////////Load Music/Audio////////////////

  minim = new Minim(this);
  sndJump = minim.loadSample("jump.wav");
  sndCoin = minim.loadSample("coin.wav");
  life = minim.loadSample("life.wav");
  click = minim.loadSample("click.wav");
  tick = minim.loadSample("tick.wav");
  titleMusic = minim.loadFile("titleMusic.mp3");
  customizeMusic = minim.loadFile("customizeMusic.mp3");
  gameMusic = minim.loadFile("gameMusic.mp3");
  gameOver = minim.loadFile("gameOver.mp3");
  howToCredits = minim.loadFile("howToCredits.mp3");

///////////////////change app icon/////////////////////////

PGraphics icon = createGraphics(32, 32, JAVA2D);
icon.beginDraw();
icon.image(iconHead,0,0,32,32);
icon.endDraw();
frame.setIconImage(icon.image);  


////////////////////Load reset, etc////////////

  resetGame();
    
  cameraOffsetX = 0.0f;
  
}

public void resetGame() {
  
  thePlayer.reset(); // reset the coins collected number, etc.  
  theWorld.reload(); // reset world map
}

public void outlinedText(String sayThis, float atX, float atY) {
  fill(0);
  text(sayThis, atX,atY);
}

public void updateCameraPosition() {

  //set "camera" to follow character within world grid boundary
  
  int rightEdge = World.GRID_UNITS_WIDE*World.GRID_UNIT_SIZE-width;
  
  cameraOffsetX = thePlayer.position.x-width*.5f;
  if(cameraOffsetX < 0) {
    cameraOffsetX = 0;
  }  
  if(cameraOffsetX > rightEdge) {
    cameraOffsetX = rightEdge;
  }
}

public void draw() {
  noCursor();
  
  imageMode(CENTER);
  rectMode(CENTER);
  textAlign(CENTER);

////////////////////////monitoring//////////////////////////////
  
  println("layerSelect = "+layerSelect,"level = "+level,"menuDelay = "+menuDelay,"FR = "+frameRate,"menuSelect = "+menuSelect);
  println("camera = "+cameraOffsetX,"isOnGround = "+thePlayer.isOnGround);
/////////////////////////Text Flashing///////////////////////////  
  
  blinker -= 8.4f;

  if(blinker < 0) {
  blinker = 255;
  }

  if (blinker > 125) {
    flash = 255;
  } else {
    flash = 0;
  }
///////////////////////Eye Blinking///////////////////////////

    blink+=2;
  if(blink == 1000) {
    blink = 0;
  }
  
///////////////////////Menu Timer and reset if left alone//////////////////////////

    if(menuDelay == 4000 && level == 1 || menuDelay == 4000 && level == 3 || menuDelay > 500 && level == 4) {
      level = 0;
      start = false;
      choice = false;
      select = false;
      menuDelay = 0;
      layerSelect = 0;
      fade = 75;
      sockCall=shoeCall=undiesCall=pantsCall=underShirtCall=watchCall=handsCall=hatCall=overShirtCall=tieCall=sweaterVestCall=collarCall=jacketCall=outerCoatCall=scarfCall = 0;
    }

///////////////////////constraints///////////////////

lives = constrain(lives,0,3);
sockCall = constrain(sockCall,0,9);
shoeCall = constrain(shoeCall,0,8);
undiesCall = constrain(undiesCall,0,11);
pantsCall = constrain(pantsCall,0,24);
watchCall = constrain(watchCall,0,1);
handsCall = constrain(handsCall,0,3);
hatCall = constrain(hatCall,0,2);
underShirtCall = constrain(underShirtCall,0,34);
overShirtCall = constrain(overShirtCall,0,48);
tieCall = constrain(tieCall,0,13);
sweaterVestCall = constrain(sweaterVestCall,0,8);
collarCall = constrain(collarCall,0,48);
jacketCall = constrain(jacketCall,0,14);
outerCoatCall = constrain(outerCoatCall,0,10);
scarfCall = constrain(scarfCall,0,4);

/////////////////////////music///////////////////////////

musicControl();

////////////////frameRate control///////////////////////

if(level != 3) {
  frameRate(30);
  menuDelay+=2;
}else{
  frameRate(60);
  menuDelay++;
}

///////////////////////game menu////////////////////////

switch(level) {  
  case LEVEL_TITLE:
  background(0,255,0);

  menuSelect = constrain(menuSelect,0,2);

if(menuDelay > 20 && menuDelay < 175) { 
   stroke(255,84,0);
  strokeWeight(2);
  line(0,height*.5f+2,width,height*.5f+2); 
  textSize(20);
  fill(255);
  text("ONE LINE\u00ae",width*.5f,height*.5f-1);
  text("\nPresents",width*.5f,height*.5f-9);
 
  if (start == true) {
    menuDelay = 200;
    start = false;
  }
  }
  
if(menuDelay > 200) {
  
  fade+=2;
  fade = constrain(fade,0,255);
  
  image(painter,width*.5f,height*.33f,450,300);
  if(fade>75 && fade < 107){
    titleFrame=0;
  } else if ( fade >107 && fade < 139){
    titleFrame=1;
  } else if( fade >139 && fade < 171) {
    titleFrame=2;
  }else if(fade > 171 && fade < 255){
    titleFrame=3;
  }

    tint(255);
    image(ragzTitle[titleFrame],width*.5f,height*.33f,450,300);
    
  if(start == true && fade < 200) {
    fade = 255;
    titleFrame=3;
    start = false;
  }
  
  if(fade > 200) {
  textSize(30);
  fill(255);
  text("START\nHOW TO PLAY\nCREDITS",width*.5f,height*.64f);
  textSize(20);
  text("TM AND \u00a9 1986 ONE LINE\u00ae",width*.5f,height*.88f); 

    textSize(30);
  if(menuSelect == 0) {
    text("<",width*.7f,height*.64f);
  } else if (menuSelect == 1) {
    text("\n<",width*.7f,height*.64f);
  } else if (menuSelect == 2) {
    text("\n\n<",width*.7f,height*.64f);
  }
  
//button control

if (start == true) {
    menuDelay = 0;
    start = false;
if( menuSelect == 0) {
  level = 1;
} 
if(menuSelect == 1) {
  level = 5;
}
if(menuSelect == 2) {
  level = 6;
}
}
}  

  
//plash screen no hands reset
  if (menuDelay == 2000) {
    menuDelay = 0;
    fade = 75;
  }
  }
  break;
  
///////////////////////customize screen///////////////////////
  
  case LEVEL_CUSTOMIZE:
         
  background(0,255,0);
  
  fill(228,96,24);
  strokeWeight(10);
  stroke(228,0,96);
  rect(width*.2f,height*.52f,200,450);
  fill(88,248,156);
  stroke(252,56,0);
  rect(width*.66f,height*.52f,420,450);
 
  fill(255,flash);
  textSize(30);
  text("CUSTOMIZE THE PLAYER CHARACTER!",width*.5f,45);

menuDisplay();
thePlayer.draw();

break;

/////////////////////level about to start///////////////////

case LEVEL_LEADIN:

background(0,255,0);
textSize(30);
fill(255);
text("LEVEL 1-1\n\n\nCOLLECT THE FUNDZ",width*.5f,height*.4f);

if(start==true || menuDelay > 300){
 start= false;
level = 3;
menuDelay = 0;
}

break;

/////////////////////////game screen turn on//////////////////

  case LEVEL_GAME:
  
  background(0,255,255); 
  tint(255);

//background that follows player (illusion of distance)

  for(int i = 0; i < width*2;i=i+400) {
  image(cloud,width*.5f-0.05f*thePlayer.position.x+i,60,60,60);
  image(cloudFar,width*.2f-0.01f*thePlayer.position.x+i-100,160,60,60);
  }
  for(int i = 0; i < width*1.5f;i=i+240) {
  image(worldBackgroundFar,120-0.01f*thePlayer.position.x+i,510,240,180);
  image(worldBackground,120-0.05f*thePlayer.position.x+i,510,240,180);    
  }
  
  pushMatrix();
  translate(-cameraOffsetX,0.0f); // affects all upcoming graphics calls, until popMatrix
  
  rectMode(CORNER);
  imageMode(CORNER);
  
  updateCameraPosition();
  theWorld.render();
  thePlayer.inputCheck();
  thePlayer.draw();
  thePlayer.move();
  
  popMatrix(); // undoes the translate function from earlier in draw()
  
  if(focused == false) { // does the window currently not have keyboard focus?
    textAlign(CENTER);
    outlinedText("Click this area to play.\n\nUse arrows to move.\nSpacebar to jump.",width*.5f, height*.33f); //CLICK IN THE GAME!!
  } else {
    textAlign(LEFT); 
    outlinedText("Coins: "+thePlayer.coinsCollected,8, 30);
    textAlign(RIGHT);
    outlinedText("Lives: "+lives,width-8,30);
  }

// death
  if (lives == 0) {
    thePlayer.coinsCollected = 0;
    level = 4;
    lives = 3;
    menuDelay = 0;
    start = false;
  }
  
break;

///////////////////////game over///////////////////////

  case LEVEL_GAMEOVER:
    
    background(0,255,0);
    
    fill(255,flash);
    text("GAME OVER",width*.5f,height*.5f);
    sockCall=shoeCall=undiesCall=pantsCall=underShirtCall=watchCall=handsCall=hatCall=overShirtCall=tieCall=sweaterVestCall=collarCall=jacketCall=outerCoatCall=scarfCall = 0;
    
    if(start == true) {
      start = false;
      menuDelay = 500;
    }
break;

case LEVEL_HOWTO:
  
  background(0,255,0);
  noFill();
  stroke(255,84,0);
  strokeWeight(5);
  rect(width*.5f,height*.55f,675,430);

  textSize(30);
  fill(255);
  text("HOW TO PLAY",width*.5f,height*.1f);
  textSize(20);
  text("Dress the artist in his RAGZ before you head out into the wasteland to collect funding!\n\nNavigate the customization screen with the ARROW KEYS/JOYSTICK/D-PAD and when you are all set, press the ENTER/RETURN/A BUTTON to confirm you selection.\n\nOnce in the RAGZ wasteland, move around with the ARROW KEYS/JOYSTICK/D-PAD and jump by pressing the SPACEBAR/A BUTTON.\n\nCan you gather up all of the grant money to make better art, or will you fall to your death without any coin!?",width*.5f,height*.58f,650,400);
  
if (start == true) {
    level = 0;
    menuDelay = 200;
    fade = 75;
    start = false;
    menuSelect = 0;
  } else if (menuDelay == 2300) {
    level = 0;
    menuDelay = 200;
    fade = 75;
    start = false;
    menuSelect = 0;
  }
  
break;

case LEVEL_CREDITS:
  
  background(0,255,0);
  noFill();
  stroke(255,84,0);
  strokeWeight(5);
  rect(width*.5f,height*.5f,675,400);

  textSize(30);
  fill(255);
  text("CREDITS",width*.5f,height*.1f);
  textSize(20);
  text("-PROGRAMMING & GRAPHICS-\nANTHONY MONTUORI\nPLATFORMER ENGINE MODIFIED FROM CODE\nBY Chris DeLeon",width*.5f,height*.25f);
  text("-AUDIO-\nNYAN CAT 8-BIT by SWABASOC\nCUSTOMIZATION MUSIC - The Goonies II (KONAMI)\nBED INTRUDER 8-BIT by Ralph Vickers\nHOW TO AND CREDITS MUSIC - Rainbow Islands:\nThe Story of Bubble Bobble 2 (Taitos)\nGAMEOVER MUSIC - Double Dragon II: The Revenge\n(Technos Japan) ",width*.5f,height*.47f);
  
  text(versionNumber,width*.5f,height*.95f);
  
if (start == true) {
    level = 0;
    menuDelay = 200;
    fade = 75;
    start = false;
    menuSelect = 0;
  } else if (menuDelay == 2300) {
    level = 0;
    menuDelay = 200;
    fade = 75;
    start = false;
    menuSelect = 0;
  }
    
break;
}
}

class Player {
  PVector position,velocity; // PVector contains two floats, x and y

  Boolean isOnGround; // used to keep track of whether the player is on the ground. useful for control and animation.
  Boolean facingRight; // used to keep track of which direction the player last moved in. used to flip player image.
  int animDelay; // countdown timer between animation updates
  int animFrame; // keeps track of which animation frame is currently shown for the player
  int coinsCollected; // a counter to keep a tally on how many coins the player has collected
  
  static final float JUMP_POWER = 11.0f; // how hard the player jolts upward on jump
  static final float RUN_SPEED = 4.0f; // force of player movement on ground, in pixels/cycle
  static final float AIR_RUN_SPEED = 1.f; // like run speed, but used for control while in the air
  static final float SLOWDOWN_PERC = 0.6f; // friction from the ground. multiplied by the x speed each frame.
  static final float AIR_SLOWDOWN_PERC = .85f; // resistance in the air, otherwise air control enables crazy speeds
  static final int RUN_ANIMATION_DELAY = 4; // how many game cycles pass between animation updates?
  static final float TRIVIAL_SPEED = 1.0f; // if under this speed, the player is drawn as standing still
  
  Player() {
    isOnGround = false;
    facingRight = true;
    position = new PVector();
    velocity = new PVector();
    reset();
  }
  
  public void reset() {
    animDelay = 0;
    animFrame = 0;
    velocity.x = 0;
    velocity.y = 0;
    coinsCollected = 0;
  }
  
  public void inputCheck() {
    // keyboard flags are set by keyPressed/keyReleased in the main .pde
    
    float speedHere = (isOnGround ? RUN_SPEED : AIR_RUN_SPEED);
    float frictionHere = (isOnGround ? SLOWDOWN_PERC : AIR_SLOWDOWN_PERC);
    
    if(holdingLeft) {
      velocity.x -= speedHere;
    } else if(holdingRight) {
      velocity.x += speedHere;
    } 
    velocity.x *= frictionHere; // causes player to constantly lose speed
    
    if(isOnGround) { // player can only jump if currently on the ground
      if(holdingSpace || holdingUp) { // either up arrow or space bar cause the player to jump
        sndJump.trigger(); // play sound
        velocity.y = -JUMP_POWER; // adjust vertical speed
        isOnGround = false; // mark that the player has left the ground, i.e. cannot jump again for now
      }
    }
  }
  
  public void checkForWallBumping() {
    int guyWidth = characterStart.width; // think of image size of player standing as the player's physical size
    int guyHeight = characterStart.height;
    int wallProbeDistance = PApplet.parseInt(guyWidth*0.5f);
    int ceilingProbeDistance = PApplet.parseInt(guyHeight);   
    
    // used as probes to detect running into walls, ceiling
    PVector leftSideHigh,rightSideHigh,leftSideLow,rightSideLow,topSide;
    leftSideHigh = new PVector();
    rightSideHigh = new PVector();
    leftSideLow = new PVector();
    rightSideLow = new PVector();
    topSide = new PVector();

    // update wall probes
    leftSideHigh.x = leftSideLow.x = position.x - wallProbeDistance; // left edge of player
    rightSideHigh.x = rightSideLow.x = position.x + wallProbeDistance; // right edge of player
    leftSideLow.y = rightSideLow.y = position.y-0.2f*guyHeight; // shin high
    leftSideHigh.y = rightSideHigh.y = position.y-0.8f*guyHeight; // shoulder high

    topSide.x = position.x; // center of player
    topSide.y = position.y-ceilingProbeDistance; // top of guy
    
//    rect(topSide.x,topSide.y,5,5);
//    rect(rightSideHigh.x,rightSideHigh.y,5,5);
//    rect(rightSideLow.x,rightSideLow.y,5,5);
//    rect(leftSideHigh.x,leftSideHigh.y,5,5);
//    rect(leftSideLow.x,leftSideLow.y,5,5);
    
    // if any edge of the player is inside a red killblock, reset the round
    if( theWorld.worldSquareAt(topSide)==World.TILE_KILLBLOCK ||
         theWorld.worldSquareAt(leftSideHigh)==World.TILE_KILLBLOCK ||
         theWorld.worldSquareAt(leftSideLow)==World.TILE_KILLBLOCK ||
         theWorld.worldSquareAt(rightSideHigh)==World.TILE_KILLBLOCK ||
         theWorld.worldSquareAt(rightSideLow)==World.TILE_KILLBLOCK ||
         theWorld.worldSquareAt(position)==World.TILE_KILLBLOCK) {
      resetGame();
      lives--;
      life.trigger();
      return; // any other possible collisions would be irrelevant, exit function now
    }
    
    // the following conditionals just check for collisions with each bump probe
    // depending upon which probe has collided, we push the player back the opposite direction
    
    if( theWorld.worldSquareAt(topSide)==World.TILE_SOLID||
        theWorld.worldSquareAt(topSide)==World.TILE_SOLIDTHIN||
        theWorld.worldSquareAt(topSide)==World.TILE_EDGEL||
        theWorld.worldSquareAt(topSide)==World.TILE_EDGER) {
      if(theWorld.worldSquareAt(position)==World.TILE_SOLID||
         theWorld.worldSquareAt(position)==World.TILE_SOLIDTHIN||
         theWorld.worldSquareAt(position)==World.TILE_EDGEL||
         theWorld.worldSquareAt(position)==World.TILE_EDGER) {
        position.sub(velocity);
        velocity.x=0.0f;
        velocity.y=0.0f;
      } else {
        position.y = theWorld.bottomOfSquare(topSide)+ceilingProbeDistance;
        if(velocity.y < 0) {
          velocity.y = 0.0f;
        }
      }
    }
    
    if( theWorld.worldSquareAt(leftSideLow)==World.TILE_SOLID||
        theWorld.worldSquareAt(leftSideLow)==World.TILE_SOLIDTHIN||
        theWorld.worldSquareAt(leftSideLow)==World.TILE_EDGEL||
        theWorld.worldSquareAt(leftSideLow)==World.TILE_EDGER) {
//      position.x = theWorld.rightOfSquare(leftSideLow)+wallProbeDistance;
      if(velocity.x < 0) {
        velocity.x = 0.0f;
      }
    }
   
    if( theWorld.worldSquareAt(leftSideHigh)==World.TILE_SOLID||
        theWorld.worldSquareAt(leftSideHigh)==World.TILE_SOLIDTHIN||
        theWorld.worldSquareAt(leftSideHigh)==World.TILE_EDGEL||
        theWorld.worldSquareAt(leftSideHigh)==World.TILE_EDGER) {
      position.x = theWorld.rightOfSquare(leftSideHigh)+wallProbeDistance;
      if(velocity.x < 0) {
        velocity.x = 0.0f;
      }
    }
   
    if( theWorld.worldSquareAt(rightSideLow)==World.TILE_SOLID||
        theWorld.worldSquareAt(rightSideLow)==World.TILE_SOLIDTHIN||
        theWorld.worldSquareAt(rightSideLow)==World.TILE_EDGEL||
        theWorld.worldSquareAt(rightSideLow)==World.TILE_EDGER) {
//      position.x = theWorld.leftOfSquare(rightSideLow)-wallProbeDistance;
      if(velocity.x > 0) {
        velocity.x = 0.0f;
      }
    }
   
    if( theWorld.worldSquareAt(rightSideHigh)==World.TILE_SOLID||
        theWorld.worldSquareAt(rightSideHigh)==World.TILE_SOLIDTHIN||
        theWorld.worldSquareAt(rightSideHigh)==World.TILE_EDGEL||
        theWorld.worldSquareAt(rightSideHigh)==World.TILE_EDGER) {
      position.x = theWorld.leftOfSquare(rightSideHigh)-wallProbeDistance;
      if(velocity.x > 0) {
        velocity.x = 0.0f;
      }
    }
  }

  public void checkForCoinGetting() {
    PVector centerOfPlayer;
    // we use this to check for coin overlap in center of player
    // (remember that "position" is keeping track of bottom center of feet)
    centerOfPlayer = new PVector(position.x,position.y-characterStart.height*.5f);

    if(theWorld.worldSquareAt(centerOfPlayer)==World.TILE_COIN) {
      theWorld.setSquareAtToThis(centerOfPlayer, World.TILE_EMPTY);
      sndCoin.trigger();
      coinsCollected++;
    }
  }

  public void checkForFalling() {
    // If we're standing on an empty or coin tile, we're not standing on anything. Fall!
    if(theWorld.worldSquareAt(position)==World.TILE_EMPTY ||
       theWorld.worldSquareAt(position)==World.TILE_COIN ||
       theWorld.worldSquareAt(position)==World.TILE_SPIKE) {
       isOnGround=false;
    }
    
    if(isOnGround==false) { // not on ground?    
      if(theWorld.worldSquareAt(position)==World.TILE_SOLID||
         theWorld.worldSquareAt(position)==World.TILE_SOLIDTHIN||
         theWorld.worldSquareAt(position)==World.TILE_EDGEL||
         theWorld.worldSquareAt(position)==World.TILE_EDGER) { // landed on solid square?
        isOnGround = true;
        position.y = theWorld.topOfSquare(position);
        velocity.y = 0.0f;
      } else { // fall
        velocity.y += GRAVITY_POWER;
      }
    }
  }

  public void move() {
    position.add(velocity);
    
    checkForWallBumping();  
    checkForCoinGetting();
    checkForFalling();
  }
  
  public void draw() {

//draw the character at the customize screen
    
if(level == 1) {
  image(characterStart,width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(characterLegs,width*.2f,height*.52f,characterSizeX,characterSizeY);
  
  layerSelect = constrain(layerSelect,0,13);
 
  blink+=2;
  if(blink == 1000) {
    blink = 0;
  }
  
  if(blink > 190 && blink < 200 || blink > 970 && blink < 980) {
  image(characterEyelids,width*.2f,height*.52f,characterSizeX,characterSizeY);
  }

  image(sock[sockCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(shoe[shoeCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(undies[undiesCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(pants[pantsCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(watch[watchCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(hands[handsCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(hat[hatCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(underShirt[underShirtCall],width*.2f,height*.52f,characterSizeX,characterSizeY);  
  image(overShirt[overShirtCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(tie[tieCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(sweaterVest[sweaterVestCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(collar[collarCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(jacket[jacketCall],width*.2f,height*.52f,characterSizeX,characterSizeY);
  image(outerCoat[outerCoatCall],width*.2f,height*.52f,characterSizeX,characterSizeY); 
  image(scarf[scarfCall],width*.2f,height*.52f,characterSizeX,characterSizeY); 
    }
 
// draw the character in the game 
    
if (level == 3) {   
    int guyWidth = characterStart.width;
    int guyHeight = characterStart.height;
    
    if(velocity.x<-TRIVIAL_SPEED) {
      facingRight = false;
    } else if(velocity.x>TRIVIAL_SPEED) {
      facingRight = true;
    }
    
pushMatrix(); // lets us compound/accumulate translate/scale/rotate calls, then undo them all at once
translate(position.x,position.y);
imageMode(CORNER);

if(facingRight==true) {
      scale(-1,1); // flip horizontally by scaling horizontally by -100%
    }
    
translate(-guyWidth,-guyHeight-37); // drawing images centered on character's feet

if(isOnGround==false) { // falling or jumping
      image(characterStart, 0,0,characterGameSizeX,characterGameSizeY);
      image(characterLegsRun1, 0,0,characterGameSizeX,characterGameSizeY);
      if(blink > 190 && blink < 200 || blink > 970 && blink < 980) {
          image(characterEyelids,0,0,characterGameSizeX,characterGameSizeY);
      } 
  image(sockRun1[sockCall],0,0,characterGameSizeX,characterGameSizeY);
  image(shoeRun1[shoeCall],0,0,characterGameSizeX,characterGameSizeY);
  image(undiesRun1[undiesCall],0,0,characterGameSizeX,characterGameSizeY);
  image(pantsRun1[pantsCall],0,0,characterGameSizeX,characterGameSizeY);
  image(watch[watchCall],0,0,characterGameSizeX,characterGameSizeY);
  image(underShirt[underShirtCall],0,0,characterGameSizeX,characterGameSizeY);
  image(hands[handsCall],0,0,characterGameSizeX,characterGameSizeY);
  image(hat[hatCall],0,0,characterGameSizeX,characterGameSizeY);
  image(overShirt[overShirtCall],0,0,characterGameSizeX,characterGameSizeY);
  image(tie[tieCall],0,0,characterGameSizeX,characterGameSizeY);
  image(sweaterVest[sweaterVestCall],0,0,characterGameSizeX,characterGameSizeY);
  image(collar[collarCall],0,0,characterGameSizeX,characterGameSizeY);
  image(jacket[jacketCall],0,0,characterGameSizeX,characterGameSizeY);
  image(outerCoat[outerCoatCall],0,0,characterGameSizeX,characterGameSizeY);
  image(scarf[scarfCall],0,0,characterGameSizeX,characterGameSizeY);
    } else if(abs(velocity.x)<TRIVIAL_SPEED) { // not moving fast, i.e. standing
      image(characterStart, 0,0,characterGameSizeX,characterGameSizeY);
      image(characterLegs, 0,0,characterGameSizeX,characterGameSizeY);
        if(blink > 190 && blink < 200 || blink > 970 && blink < 980) {
          image(characterEyelids,0,0,characterGameSizeX,characterGameSizeY);
        }  
  image(sock[sockCall],0,0,characterGameSizeX,characterGameSizeY);
  image(shoe[shoeCall],0,0,characterGameSizeX,characterGameSizeY);
  image(undies[undiesCall],0,0,characterGameSizeX,characterGameSizeY);
  image(pants[pantsCall],0,0,characterGameSizeX,characterGameSizeY);
  image(watch[watchCall],0,0,characterGameSizeX,characterGameSizeY);
  image(underShirt[underShirtCall],0,0,characterGameSizeX,characterGameSizeY);
  image(hands[handsCall],0,0,characterGameSizeX,characterGameSizeY);
  image(hat[hatCall],0,0,characterGameSizeX,characterGameSizeY);
  image(overShirt[overShirtCall],0,0,characterGameSizeX,characterGameSizeY);
  image(tie[tieCall],0,0,characterGameSizeX,characterGameSizeY);
  image(sweaterVest[sweaterVestCall],0,0,characterGameSizeX,characterGameSizeY);
  image(collar[collarCall],0,0,characterGameSizeX,characterGameSizeY);
  image(jacket[jacketCall],0,0,characterGameSizeX,characterGameSizeY);
  image(outerCoat[outerCoatCall],0,0,characterGameSizeX,characterGameSizeY);
  image(scarf[scarfCall],0,0,characterGameSizeX,characterGameSizeY);
    } else { // running. Animate.
      if(animDelay--<0) {
        animDelay=RUN_ANIMATION_DELAY;
        if(animFrame==0) {
          animFrame=1;
        } else {
          animFrame=0;
        }
      }
      
if(animFrame==0) {
      image(characterStart, 0,0,characterGameSizeX,characterGameSizeY);
      image(characterLegsRun1, 0,0,characterGameSizeX,characterGameSizeY);
      if(blink > 190 && blink < 200 || blink > 970 && blink < 980) {
         image(characterEyelids,0,0,characterGameSizeX,characterGameSizeY);
      }
  image(sockRun1[sockCall],0,0,characterGameSizeX,characterGameSizeY);
  image(shoeRun1[shoeCall],0,0,characterGameSizeX,characterGameSizeY);
  image(undiesRun1[undiesCall],0,0,characterGameSizeX,characterGameSizeY);
  image(pantsRun1[pantsCall],0,0,characterGameSizeX,characterGameSizeY);
  image(watch[watchCall],0,0,characterGameSizeX,characterGameSizeY);
  image(underShirt[underShirtCall],0,0,characterGameSizeX,characterGameSizeY);
  image(hands[handsCall],0,0,characterGameSizeX,characterGameSizeY);
  image(hat[hatCall],0,0,characterGameSizeX,characterGameSizeY);
  image(overShirt[overShirtCall],0,0,characterGameSizeX,characterGameSizeY);
  image(tie[tieCall],0,0,characterGameSizeX,characterGameSizeY);
  image(sweaterVest[sweaterVestCall],0,0,characterGameSizeX,characterGameSizeY);
  image(collar[collarCall],0,0,characterGameSizeX,characterGameSizeY);
  image(jacket[jacketCall],0,0,characterGameSizeX,characterGameSizeY);
  image(outerCoat[outerCoatCall],0,0,characterGameSizeX,characterGameSizeY);
  image(scarf[scarfCall],0,0,characterGameSizeX,characterGameSizeY);
      } else {
      image(characterStart, 0,0,characterGameSizeX,characterGameSizeY);
      image(characterLegsRun2, 0,0,characterGameSizeX,characterGameSizeY);
        if(blink > 190 && blink < 200 || blink > 970 && blink < 980) {
          image(characterEyelids,0,0,characterGameSizeX,characterGameSizeY);
        }
  image(sockRun2[sockCall],0,0,characterGameSizeX,characterGameSizeY);
  image(shoeRun2[shoeCall],0,0,characterGameSizeX,characterGameSizeY);
  image(undiesRun2[undiesCall],0,0,characterGameSizeX,characterGameSizeY);
  image(pantsRun2[pantsCall],0,0,characterGameSizeX,characterGameSizeY);
  image(watch[watchCall],0,0,characterGameSizeX,characterGameSizeY);
  image(underShirt[underShirtCall],0,0,characterGameSizeX,characterGameSizeY);
  image(hands[handsCall],0,0,characterGameSizeX,characterGameSizeY);
  image(hat[hatCall],0,0,characterGameSizeX,characterGameSizeY);
  image(overShirt[overShirtCall],0,0,characterGameSizeX,characterGameSizeY);
  image(tie[tieCall],0,0,characterGameSizeX,characterGameSizeY);
  image(sweaterVest[sweaterVestCall],0,0,characterGameSizeX,characterGameSizeY);
  image(collar[collarCall],0,0,characterGameSizeX,characterGameSizeY);
  image(jacket[jacketCall],0,0,characterGameSizeX,characterGameSizeY);
  image(outerCoat[outerCoatCall],0,0,characterGameSizeX,characterGameSizeY);
  image(scarf[scarfCall],0,0,characterGameSizeX,characterGameSizeY);
      }
    }    
    popMatrix(); // undoes all translate/scale/rotate calls since the pushMatrix earlier in this function
    }
  }
}

///////////////////////////key control///////////////////////

public void keyPressed() {
   if (key == ENTER) {
    start = true;
  } else {
    start = false;
  }
  
   if (level != 3) {
    holdingUp=holdingRight=holdingLeft=holdingSpace=false;
  } 
  
  if(keyCode == UP) {
    if(level == 0 && fade > 200 && menuSelect >=1) {
      menuSelect--;
      click.trigger();  
    }
    if(level == 1) {
      menuDelay=0;
      if (choice == false) {
        layerSelect++;
        click.trigger();
       } else {
        select = false;
        click.trigger();
      }
    }
    
  }
  if(keyCode == DOWN) {
    if(level == 0 && fade > 200 && menuSelect <=1) {
      menuSelect++;
      click.trigger();
    }
    if(level == 1) {
      menuDelay=0;
      if (choice == false) {
        layerSelect--;
        click.trigger();
      } else {
        select = true;
        click.trigger();
      }
    }
  }

//clothing toggle left and right
if(keyCode == LEFT) {
  menuDelay= 0;
  if(level == 1 && choice == false) {
    if (layerSelect == 0 && sockCall > 0) {
    sockCall--;
    tick.trigger();
  }
    if (layerSelect == 1 && shoeCall > 0) {
    shoeCall--;
    tick.trigger();
  }
    if (layerSelect == 2 && undiesCall > 0) {
    undiesCall--;
    tick.trigger();
  }
    if (layerSelect == 3 && pantsCall > 0) {
    pantsCall--;
    tick.trigger();
  }
    if (layerSelect == 4 && watchCall > 0) {
    watchCall--;
    tick.trigger();
  }
    if (layerSelect == 5 && handsCall > 0) {
    handsCall--;
    tick.trigger();
  }
    if (layerSelect == 6 && hatCall > 0) {
    hatCall--;
    tick.trigger();
  }
    if (layerSelect == 7 && underShirtCall > 0) {
    underShirtCall--;
    tick.trigger();
  }
    if (layerSelect == 8 && overShirtCall > 0) {
    overShirtCall--;
    collarCall--;
    tick.trigger();
  }
    if (layerSelect == 9 && tieCall > 0) {
    tieCall--;
    tick.trigger();
  }
    if (layerSelect == 10 && sweaterVestCall > 0) {
    sweaterVestCall--;
    tick.trigger();
  }
    if (layerSelect == 11 && jacketCall > 0) {
    jacketCall--;
    tick.trigger();
  }
    if (layerSelect == 12 && outerCoatCall > 0) {
    outerCoatCall--;
    tick.trigger();
  }
    if (layerSelect == 13 && scarfCall > 0) {
    scarfCall--;
    tick.trigger();
  }
  }
}

if(keyCode == RIGHT){
  menuDelay=0;
  if(level == 1 && choice == false){
    if (layerSelect == 0 && sockCall < 9) {
    sockCall++;
    tick.trigger();
  }
    if (layerSelect == 1 && shoeCall < 8) {
    shoeCall++;
    tick.trigger();
  }
  if (layerSelect == 2 && undiesCall < 11) {
    undiesCall++;
    tick.trigger();
  }
  if (layerSelect == 3 && pantsCall < 24) {
    pantsCall++;
    tick.trigger();
  }
  if (layerSelect == 4 && watchCall < 1) {
    watchCall++;
    tick.trigger();
  }
  if (layerSelect == 5 && handsCall < 3) {
    handsCall++;
    tick.trigger();
  }
  if (layerSelect == 6 && hatCall < 2) {
    hatCall++;
    tick.trigger();
  }
  if (layerSelect == 7 && underShirtCall < 34) {
    underShirtCall++;
    tick.trigger();
  } 
  if (layerSelect == 8 && overShirtCall < 48) {
    overShirtCall++;
    collarCall++;
    tick.trigger();
  }
  if (layerSelect == 9 && tieCall < 13) {
    tieCall++;
    tick.trigger();
  }
  if (layerSelect == 10 && sweaterVestCall < 8) {
    sweaterVestCall++;
    tick.trigger();
  }
  if (layerSelect == 11 && jacketCall < 14) {
    jacketCall++;
    tick.trigger();
  }
  if (layerSelect == 12 && outerCoatCall < 10) {
    outerCoatCall++;
    tick.trigger();
  }
  if (layerSelect == 13 && scarfCall < 4) {
    scarfCall++;
    tick.trigger();
  }
  }
}

  //character control
  
    if (level == 3 && keyCode == LEFT) {
      holdingLeft = true;
      menuDelay = 0;
    }
    if (level == 3 && keyCode == RIGHT) {
      holdingRight = true;
      menuDelay = 0;
    }
    if (level == 3 && keyCode == ' ') {
      holdingSpace = true;
      menuDelay = 0;
    }
}

public void keyReleased() {
  
    if (level == 3 && keyCode == LEFT) {
      holdingLeft = false;
    }
    if (level == 3 && keyCode == RIGHT) {
      holdingRight = false;
    }
    if (level == 3 && keyCode == ' ') {
      holdingSpace = false;
    }
  }


public void menuDisplay() {
  if(layerSelect > 13) {
    layerSelect = 0;
  }
  if(layerSelect < 0) {
    layerSelect = 13;
  }

//////////////////////////choice text///////////////////////

if(choice == false) {
  
    for(int i = 0; i < 420;i=i+30) {
    stroke(255);
    rect(width*.8f,height*.2f+i,150,3);
  }
  textAlign(LEFT);
  textSize(20);
  if(layerSelect == 0) {
    fill(200,25,200);
    noStroke();
    rect(width*.71f+15.9f*sockCall,height*.2f+390,6,25);
  text("SOCKS",width*.43f,height*.21f+390);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+15.9f*sockCall,height*.2f+390,6,25);
    fill(75);
    text("SOCKS",width*.43f,height*.21f+390);
  }
  if(layerSelect == 1) {
     fill(200,25,200);
     noStroke();
     rect(width*.71f+17.9f*shoeCall,height*.2f+360,6,25);
     text("SHOES",width*.43f,height*.21f+360);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+17.9f*shoeCall,height*.2f+360,6,25);
    fill(75);
    text("SHOES",width*.43f,height*.21f+360);
  }
  if(layerSelect == 2) {
    fill(200,25,200);
    noStroke();
    rect(width*.71f+13*undiesCall,height*.2f+330,6,25);
  text("UNDIES",width*.43f,height*.21f+330);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+13*undiesCall,height*.2f+330,6,25);
    fill(75);
    text("UNDIES",width*.43f,height*.21f+330);
  }
  if(layerSelect == 3) {
        fill(200,25,200);
    noStroke();
    rect(width*.71f+5.95f*pantsCall,height*.2f+300,6,25);
  text("PANTS",width*.43f,height*.21f+300);
  }else{
        fill(0);
    noStroke();
    rect(width*.71f+5.95f*pantsCall,height*.2f+300,6,25);
    fill(75);
    text("PANTS",width*.43f,height*.21f+300);
  }
  if(layerSelect == 4) {
    fill(200,25,200);
    noStroke();
    rect(width*.71f+143*watchCall,height*.2f+270,6,25);
  text("WATCH",width*.43f,height*.21f+270);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+143*watchCall,height*.2f+270,6,25);
    fill(75);
    text("WATCH",width*.43f,height*.21f+270);
  }
  if(layerSelect == 5) {
    fill(200,25,200);
    noStroke();
    rect(width*.71f+47.8f*handsCall,height*.2f+240,6,25);
  text("GLOVES",width*.43f,height*.21f+240);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+47.8f*handsCall,height*.2f+240,6,25);
    fill(75);
    text("GLOVES",width*.43f,height*.21f+240);
  }
  if(layerSelect == 6) {
        fill(200,25,200);
    noStroke();
    rect(width*.71f+71.5f*hatCall,height*.2f+210,6,25);
  text("HAT",width*.43f,height*.21f+210);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+71.5f*hatCall,height*.2f+210,6,25);
    fill(75);
    text("HAT",width*.43f,height*.21f+210);
  }
  if(layerSelect == 7) {
            fill(200,25,200);
    noStroke();
    rect(width*.71f+4.2f*underShirtCall,height*.2f+180,6,25);
  text("UNDERSHIRT",width*.43f,height*.21f+180);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+4.2f*underShirtCall,height*.2f+180,6,25);
    fill(75);
    text("UNDERSHIRT",width*.43f,height*.21f+180);
  }
  if(layerSelect == 8) {
    fill(200,25,200);
    noStroke();
    rect(width*.71f+2.98f*overShirtCall,height*.2f+150,6,25);
  text("OVERSHIRT",width*.43f,height*.21f+150);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+2.98f*overShirtCall,height*.2f+150,6,25);
    fill(75);
    text("OVERSHIRT",width*.43f,height*.21f+150);
  }
  if(layerSelect == 9) {
  fill(200,25,200);
  noStroke();
  rect(width*.71f+11*tieCall,height*.2f+120,6,25);
  text("TIE",width*.43f,height*.21f+120);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+11*tieCall,height*.2f+120,6,25);
    fill(75);
    text("TIE",width*.43f,height*.21f+120);
  }
  if(layerSelect == 10) {
  fill(200,25,200);
    noStroke();
    rect(width*.71f+17.9f*sweaterVestCall,height*.2f+90,6,25);
  text("SWEATER/VEST",width*.43f,height*.21f+90);
  }else{
        fill(0);
    noStroke();
    rect(width*.71f+17.9f*sweaterVestCall,height*.2f+90,6,25);
    fill(75);
    text("SWEATER/VEST",width*.43f,height*.21f+90);
  }
  if(layerSelect == 11) {
  fill(200,25,200);
    noStroke();
    rect(width*.71f+10.2f*jacketCall,height*.2f+60,6,25);
  text("JACKET",width*.43f,height*.21f+60);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+10.2f*jacketCall,height*.2f+60,6,25);
    fill(75);
    text("JACKET",width*.43f,height*.21f+60);
  }
  if(layerSelect == 12) {
  fill(200,25,200);
    noStroke();
    rect(width*.71f+14.3f*outerCoatCall,height*.2f+30,6,25);
  text("COAT",width*.43f,height*.21f+30);
  }else{
    fill(0);
    noStroke();
    rect(width*.71f+14.3f*outerCoatCall,height*.2f+30,6,25);
    fill(75);
    text("COAT",width*.43f,height*.21f+30);
  }
  if(layerSelect == 13) {
  fill(200,25,200);
    noStroke();
    rect(width*.71f+35.7f*scarfCall,height*.2f,6,25);
  text("SCARF",width*.43f,height*.21f);
  }else{
        fill(0);
    noStroke();
    rect(width*.71f+35.7f*scarfCall,height*.2f,6,25);
    fill(75);
    text("SCARF",width*.43f,height*.21f);
  }

    if(start == true) {
      choice = true;
      start = false;
  }
}else{
  fill(0);
  text("CONFIRM\nYES\nNO",width*.66f,height*.5f);
  if(select == false) {
    text("\n          ~",width*.66f,height*.5f);
    if (start == true) {
      start = false;
      menuDelay = 0;
      level=2;
  }
  }
  if(select == true) {
    text("\n\n          ~",width*.66f,height*.5f);
    if (start == true) {
      choice = false;
      start = false;
      select = false;
      layerSelect = 0;
    }
  }
}
}
public void musicControl() {
if (level == 0) {
 if(titleMusic.isPlaying()==false){
    titleMusic.play();
    titleMusic.rewind();
 }
} else {titleMusic.pause();titleMusic.rewind();}

if (level == 1) {
 if(customizeMusic.isPlaying()==false){
   customizeMusic.play();
   customizeMusic.rewind();
 }
} else {customizeMusic.pause();customizeMusic.rewind();}

if (level == 3) {
 if(gameMusic.isPlaying() == false){
   gameMusic.play();
   gameMusic.rewind();
 }
 }else{gameMusic.pause();gameMusic.rewind();}

if (level == 4) {
  gameOver.play();
}else{gameOver.rewind();}

if(level == 5 || level == 6) {
 if(howToCredits.isPlaying() == false){
    howToCredits.play();
    howToCredits.rewind();
 }
 } else {howToCredits.pause();howToCredits.rewind();}
}

public void stop() {
  sndJump.close();
  sndCoin.close();
  life.close();
  click.close();
  tick.close();
  titleMusic.close();
  customizeMusic.close();
  howToCredits.close();
  gameMusic.close();
  gameOver.close();
  minim.stop();
  super.stop();
}
class World {
  int coinsInStage; // how many coins are in the level

  int coinAnimDelay; // countdown timer between animation updates
  int coinAnimSpeed = 7; // speed between frame changes. Lower number = faster animation
  int coinAnimFrame; // keeps track of which animation frame is currently shown for the player
  
  static final int TILE_EMPTY = 0;
  static final int TILE_SOLID = 1;
  static final int TILE_COIN = 2;
  static final int TILE_KILLBLOCK = 3;
  static final int TILE_START = 4;
  static final int TILE_EARTH = 5;
  static final int TILE_CLOUD = 6;
  static final int TILE_CURVEL = 7;
  static final int TILE_CURVER = 8;
  static final int TILE_EDGEL = 9;
  static final int TILE_EDGER = 10;
  static final int TILE_BOTTOM = 11;
  static final int TILE_SIDEL = 12;
  static final int TILE_SIDER = 13;
  static final int TILE_WALLTHIN = 14;
  static final int TILE_SPIKE = 15;
  static final int TILE_SOLIDTHIN = 16;
  static final int TILE_GRASS = 17;
  
  static final int GRID_UNIT_SIZE = 60; // size, in pixels, of each world unit square
  // if the above number becomes too small, how the player's wall bumping is detected may need to be updated

  // these next 2 numbers need to match the dimensions of the example level grid below
  static final int GRID_UNITS_WIDE =120;
  static final int GRID_UNITS_TALL = 10;

  int[][] worldGrid = new int[GRID_UNITS_TALL][GRID_UNITS_WIDE]; // the game checks this one during play
  
  // the game copies this into worldGrid each reset, returning coins that have since been cleared
  int[][] start_Grid = { { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,13, 5, 5, 5, 5,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                         { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,13, 5, 5, 5, 5,12,17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,17, 0, 0, 0, 0, 2},
                         { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,17,17, 0, 0, 0, 0,17, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2, 2, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 1, 1, 1, 1, 1, 1, 1, 1, 9,10, 1, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 1, 9, 0, 0, 0, 0},
                         { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,16, 0, 0, 0, 8, 5, 5, 5, 5, 5, 5, 7, 0, 2,10, 1, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 1, 9, 2, 0, 0, 0, 0},
                         { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 1, 1, 1, 1, 1, 5, 5, 5, 5,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,17, 0, 0,14, 0,17, 0, 0,13, 5, 5,11, 5,12, 0, 0, 0, 2,10, 1, 9, 0, 0, 0, 0, 0, 0, 0, 0,10, 1, 9, 2, 0, 0, 0, 0, 0},
                         { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,17, 0, 0, 0, 8,11, 5, 5, 5, 5, 5, 5, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 1, 1, 1, 1, 1, 1, 9, 0,13, 5,12, 2,13,12, 0, 0, 0, 0, 2,10, 1, 9, 0, 0, 0, 0, 0, 0,10, 1, 9, 2, 0, 0, 0, 0, 0, 0},
                         { 0, 4, 0,17, 0, 0, 0, 0, 0, 0, 0, 0,17, 0, 0, 0,10, 1, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0,10, 1, 1, 1, 9, 0, 0, 8, 5, 5, 5, 5,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,17, 0, 0, 0, 0, 0, 0,17, 0, 0, 0,17, 0, 0, 0, 0, 0,16, 0, 0, 0, 0, 0, 8, 5,11,11, 5, 7, 0, 0,13, 5,12, 2,13,12, 0, 0, 0, 0, 0, 2,10, 1, 9, 0, 0, 0, 0,10, 1, 9, 2, 0, 0, 0, 0, 0, 0, 0},
                         {10, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 0, 0, 8, 1, 1, 9, 0, 0, 0,16, 0, 0, 0, 0, 8, 5, 7, 0, 0, 0, 0,13, 5, 5, 5,12, 0, 0, 0, 0, 0, 0,16, 0, 0, 0, 0, 0, 0, 0,10, 1, 1, 1, 1, 1, 9, 0, 0, 0,10, 1, 1, 1, 1, 9, 0, 0, 0,16, 0,14, 0, 0, 0,16, 0, 0,14, 2, 2,14, 0, 0, 0,13, 5,12, 2,13,12, 0, 0, 0, 0, 0, 0, 2,10, 1, 9, 0, 0,10, 1, 9, 2, 0, 0, 0, 0, 0, 0, 0, 0},
                         { 2, 8, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,11, 7, 0, 0, 0, 0,13,12, 0, 0, 0, 0,14, 0, 0, 0, 0, 2,14, 2, 0, 0, 0,10, 1, 1, 1, 1, 1, 9, 0, 0,17, 0, 0,14, 0, 0, 0,16, 0, 0, 0, 0, 8, 5, 5, 5,12, 0, 0, 0, 0, 0,13, 5, 5, 7, 0, 0, 0, 0,14, 0,14, 0, 0, 0,14, 0, 0,14, 2, 2,14, 0, 0, 0,13, 5,12, 0,13,12, 0, 0, 0, 0, 0, 0, 0, 2,10, 1, 9,10, 1, 9, 2, 0, 0, 0, 2, 0, 0, 0, 0,17},
                         {15,15, 8, 5, 5, 5, 5, 5, 5, 5, 5,12,15,15,15,15,15,15,13,12,15,15,15,15,14,15,15,15,15,15,14,15,15,15,15,15, 8, 5, 1, 1, 1, 1, 1, 1, 1, 9,15,14,15,15,15,14,15,15,15,15,15, 8, 5, 5,12,15,15,15,15,15,13, 5, 7,15,15,15,15,15,14,15,14,15,15,15,14,15,15,14,15,15,14,15,15,15,13, 5,12,15,13,12,15,15,15,15,15,15,15,15,15,14,15,15,14,15,15,15,15,15,15,15,15,15,15,10} };

  
  // returns what type of tile is at a given pixel coordinate
  public int worldSquareAt(PVector thisPosition) {
    float gridSpotX = thisPosition.x/GRID_UNIT_SIZE;
    float gridSpotY = thisPosition.y/GRID_UNIT_SIZE;
  
    // first a boundary check, to avoid looking outside the grid
    // if check goes out of bounds, treat it as a solid tile (wall) - Could be killblock etc.
    if(gridSpotX<0) {
      return TILE_SOLID; 
    }
    if(gridSpotX>=GRID_UNITS_WIDE) {
      return TILE_SOLID; 
    }
    if(gridSpotY<0) {
      return TILE_SOLID; 
    }
    if(gridSpotY>=GRID_UNITS_TALL) {
      return TILE_KILLBLOCK;
    }
    
    return worldGrid[PApplet.parseInt(gridSpotY)][PApplet.parseInt(gridSpotX)];
  }
  
  // changes the tile at a given pixel coordinate to be a new tile type
  // currently used to replace TILE_COIN tiles with TILE_EMPTY tiles once collected
  public void setSquareAtToThis(PVector thisPosition, int newTile) {
    int gridSpotX = PApplet.parseInt(thisPosition.x/GRID_UNIT_SIZE);
    int gridSpotY = PApplet.parseInt(thisPosition.y/GRID_UNIT_SIZE);
  
    if(gridSpotX<0 || gridSpotX>=GRID_UNITS_WIDE || 
       gridSpotY<0 || gridSpotY>=GRID_UNITS_TALL) {
      return; // can't change grid units outside the grid
    }
    
    worldGrid[gridSpotY][gridSpotX] = newTile;
  }
  
  // these helper functions help us correct for the player moving into a world tile
  public float topOfSquare(PVector thisPosition) {
    int thisY = PApplet.parseInt(thisPosition.y);
    thisY /= GRID_UNIT_SIZE;
    return PApplet.parseFloat(thisY*GRID_UNIT_SIZE);
  }
  public float bottomOfSquare(PVector thisPosition) {
    if(thisPosition.y<0) {
      return 0;
    }
    return topOfSquare(thisPosition)+GRID_UNIT_SIZE;
  }
  public float leftOfSquare(PVector thisPosition) {
    int thisX = PApplet.parseInt(thisPosition.x);
    thisX /= GRID_UNIT_SIZE;
    return PApplet.parseFloat(thisX*GRID_UNIT_SIZE);
  }
  public float rightOfSquare(PVector thisPosition) {
    if(thisPosition.x<0) {
      return 0;
    }
    return leftOfSquare(thisPosition)+GRID_UNIT_SIZE;
  }
  
  public void reload() {
    coinsInStage = 0; // we count them while copying in level data
    
    for(int i=0;i<GRID_UNITS_WIDE;i++) {
      for(int ii=0;ii<GRID_UNITS_TALL;ii++) {
        if(start_Grid[ii][i] == TILE_START) { // player start position
          worldGrid[ii][i] = TILE_EMPTY; // put an empty tile in that spot
  
          // then update the player spot to the center of that tile
          thePlayer.position.x = i*GRID_UNIT_SIZE+(GRID_UNIT_SIZE/2);
          thePlayer.position.y = ii*GRID_UNIT_SIZE+(GRID_UNIT_SIZE);
        } else {
          if(start_Grid[ii][i]==TILE_COIN) {
            coinsInStage++;
          }
          worldGrid[ii][i] = start_Grid[ii][i];
        }
      }
    }
  }
  
  public void render() { // draw the world
    
     //animation logic for coins
       if(coinAnimDelay--<0) {
        coinAnimDelay=coinAnimSpeed;
        if(coinAnimFrame==0) {
          coinAnimFrame=1;
        } else if(coinAnimFrame==1){
          coinAnimFrame=2;
        } else if(coinAnimFrame==2){
          coinAnimFrame=3;
        } else {
          coinAnimFrame=0;
        }
      }
    
    //assign graphics to tiles - could be images, could be rectangles, etc 
    for(int i=0;i<GRID_UNITS_WIDE;i++) { // for each column
      for(int ii=0;ii<GRID_UNITS_TALL;ii++) { // for each tile in that column
        
        if(worldGrid[ii][i]==TILE_SOLID) {
          image(ground,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_SPIKE) {
          image(killBlock,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_EARTH) {
          image(earth,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_GRASS) {
          image(grass,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_CURVEL) {
          image(curveLeft,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_CURVER) {
          image(curveRight,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_CLOUD) {
          image(cloud,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_EDGEL) {
          image(groundEdgeL,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_EDGER) {
          image(groundEdgeR,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_BOTTOM) {
          image(bottomEarth,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_SIDEL) {
          image(sideL,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_SIDER) {
          image(sideR,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_WALLTHIN) {
          image(wallThin,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }
        if(worldGrid[ii][i]==TILE_SOLIDTHIN) {
          image(solidThin,i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // x,y of top left corner to draw rectangle
             GRID_UNIT_SIZE,GRID_UNIT_SIZE);
        }        
        if(worldGrid[ii][i]==TILE_COIN) { // if it's a coin, draw the coin
          image(coin[coinAnimFrame],i*GRID_UNIT_SIZE,ii*GRID_UNIT_SIZE, // center of grid spot
                  GRID_UNIT_SIZE,GRID_UNIT_SIZE); // spin size wide, 1/2 height of box tall
        }
      }
    }
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--hide-stop", "RAGZ_R_1_0_3" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
